---
updatedAt: 2026-08-29T02:45:53.000Z
agentTools:
  siteIndex: https://developer.jamf.com/llms.txt
  projectIndex: https://developer.jamf.com/platform-api/llms.txt
---

# Create Computer Extension Attribute.

Create Computer Extension Attribute to collect extra inventory information.

**Required Permissions:** `extension-attributes:create`

# OpenAPI definition

```json
{
  "openapi": "3.0.1",
  "info": {
    "title": "Jamf Pro",
    "termsOfService": "https://www.jamf.com/developer-resources/api-license-agreement/",
    "version": "11.33.0",
    "description": "Comprehensive Jamf Pro management API for enterprise device management, configuration, and automation.",
    "contact": {
      "name": "Jamf Developer",
      "url": "https://developer.jamf.com"
    }
  },
  "servers": [
    {
      "url": "https://{region}.api.jamfcloud.com/pro",
      "description": "Jamf Beta API Gateway - prod",
      "variables": {
        "region": {
          "default": "us",
          "enum": [
            "us",
            "eu",
            "apac"
          ],
          "description": "Geographic deployment region"
        }
      }
    }
  ],
  "x-readme": {
    "samples-languages": [
      "curl",
      "swift",
      "ruby",
      "python"
    ],
    "explorer-enabled": false
  },
  "security": [
    {
      "oauth2": []
    }
  ],
  "paths": {
    "/v1/computer-extension-attributes": {
      "post": {
        "tags": [
          "computer-extension-attributes"
        ],
        "summary": "Create Computer Extension Attribute.",
        "description": "Create Computer Extension Attribute to collect extra inventory information.\n\n**Required Permissions:** `extension-attributes:create`",
        "requestBody": {
          "description": "Computer Extension Attribute to be created.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ComputerExtensionAttributes"
              }
            }
          },
          "required": true
        },
        "responses": {
          "201": {
            "description": "Computer Extension Attribute was successfully created.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HrefResponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request. The server could not understand the request because of invalid syntax. Possible reasons are:</br> 1) Required fields are not provided in request body.</br> 2) Fields which are not associated with provided inputType has some value.</br> 3) Any values outside of the allowed range are included in the request body.</br> 4) LDAP is not configured.</br> 5) Error occured during database create operation.</br> 6) Duplicate_Field",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiError"
                }
              }
            }
          }
        },
        "x-required-privileges": [
          "extension-attributes:create"
        ],
        "x-action": true,
        "parameters": [
          {
            "$ref": "#/components/parameters/X-Tenant-Id"
          },
          {
            "$ref": "#/components/parameters/X-Environment-Id"
          }
        ],
        "security": [
          {
            "oauth2": [
              "extension-attributes:create"
            ]
          }
        ],
        "x-required-privileges-legacy": [
          "Create Computer Extension Attributes"
        ]
      }
    }
  },
  "components": {
    "schemas": {
      "ApiError": {
        "type": "object",
        "properties": {
          "httpStatus": {
            "type": "integer",
            "description": "HTTP status of the response",
            "example": 400
          },
          "errors": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/ApiErrorCause"
            }
          }
        }
      },
      "ApiErrorCause": {
        "required": [
          "field"
        ],
        "type": "object",
        "properties": {
          "code": {
            "type": "string",
            "description": "Error-specific code that can be used to identify localization string, etc.",
            "example": "8675309"
          },
          "field": {
            "type": "string",
            "description": "Name of the field that caused the error.",
            "example": "Name"
          },
          "description": {
            "type": "string",
            "description": "A general description of error for troubleshooting/debugging. Generally this text should not be displayed to a user; instead refer to errorCode and it's localized text",
            "example": "I've just picked up a fault in the AE35 unit. It's going to go 100% failure in 72 hours"
          },
          "id": {
            "type": "string",
            "description": "id of object with error. Optional.",
            "nullable": true,
            "example": "3"
          }
        }
      },
      "ComputerExtensionAttributes": {
        "allOf": [
          {
            "$ref": "#/components/schemas/ExtensionAttributes"
          },
          {
            "required": [
              "inputType",
              "inventoryDisplayType"
            ],
            "type": "object",
            "properties": {
              "enabled": {
                "type": "boolean",
                "description": "Enabled by default, but for inputType Script we can disable it as well. <br/> Possible values are:<br/> false <br/> true",
                "example": true,
                "default": true
              },
              "inventoryDisplayType": {
                "type": "string",
                "description": "Category in which to display the extension attribute in Jamf Pro.",
                "example": "GENERAL",
                "default": "GENERAL",
                "enum": [
                  "GENERAL",
                  "HARDWARE",
                  "OPERATING_SYSTEM",
                  "USER_AND_LOCATION",
                  "PURCHASING",
                  "EXTENSION_ATTRIBUTES"
                ]
              },
              "inputType": {
                "type": "string",
                "description": "Extension attributes collect inventory data by using an input type.The type of the Input used to populate the extension attribute.",
                "default": "TEXT",
                "enum": [
                  "SCRIPT",
                  "TEXT",
                  "POPUP",
                  "DIRECTORY_SERVICE_ATTRIBUTE_MAPPING"
                ]
              },
              "scriptContents": {
                "type": "string",
                "description": "When we run this script it returns a data value each time a computer submits inventory to Jamf Pro. Provide scriptContents only when inputType is 'SCRIPT'.",
                "nullable": true,
                "example": "scriptContent"
              },
              "popupMenuChoices": {
                "minItems": 0,
                "type": "array",
                "description": "When added with list of choices while creating computer extension attributes these Pop-up menu can be displayed in inventory information. User can choose a value from the pop-up menu list when enrolling a computer any time using Jamf Pro. Provide popupMenuChoices only when inputType is 'POPUP'.",
                "example": [
                  "Test",
                  "Popup"
                ],
                "items": {
                  "type": "string",
                  "description": "Popup Menu choices."
                }
              },
              "ldapAttributeMapping": {
                "type": "string",
                "description": "Directory Service attribute use to populate the extension attribute. <br/> Required when inputType is \"DIRECTORY_SERVICE_ATTRIBUTE_MAPPING\"",
                "example": "ldapAttributeMapping"
              },
              "ldapExtensionAttributeAllowed": {
                "type": "boolean",
                "description": "Collect multiple values for this extension attribute. ldapExtensionAttributeAllowed is disabled by default, only for inputType 'DIRECTORY_SERVICE_ATTRIBUTE_MAPPING' it can be enabled. It's value cannot be modified during edit operation.<br/> Possible values are:<br/> false <br/> true <br/>",
                "example": false,
                "default": false
              },
              "manageExistingData": {
                "type": "string",
                "description": "It is used to specify to either delete or retain the extension attributes values when inputType is Script and enabled is false.",
                "example": "RETAIN",
                "enum": [
                  "RETAIN",
                  "DELETE"
                ]
              }
            }
          }
        ]
      },
      "ExtensionAttributes": {
        "required": [
          "dataType",
          "name"
        ],
        "type": "object",
        "properties": {
          "id": {
            "type": "string",
            "description": "Unique Id for Computer Extension Attribute.",
            "readOnly": true,
            "example": "1"
          },
          "name": {
            "type": "string",
            "description": "Display name for the extension attribute.",
            "example": "ComputerExtensionAttribute"
          },
          "description": {
            "type": "string",
            "description": "Description for the extension attribute.",
            "example": "Computer Extension Attribute"
          },
          "dataType": {
            "type": "string",
            "description": "Type of data being collected.",
            "default": "STRING",
            "enum": [
              "INTEGER",
              "STRING",
              "DATE"
            ]
          }
        }
      },
      "HrefResponse": {
        "type": "object",
        "properties": {
          "id": {
            "minLength": 1,
            "type": "string",
            "example": "1"
          },
          "href": {
            "type": "string",
            "example": "https://yourJamfProUrl.jamf/api/v1/resource/1"
          }
        }
      }
    },
    "parameters": {
      "X-Tenant-Id": {
        "name": "X-Tenant-Id",
        "in": "header",
        "required": false,
        "description": "The tenant UUID identifier. Send it to address tenant scope. This API is also published at environment scope — send that scope's header instead. Send exactly one scope header per request.",
        "schema": {
          "type": "string",
          "format": "uuid",
          "pattern": "^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$",
          "example": "e77c1408-10c8-4007-b177-abc9157fbcaa"
        }
      },
      "X-Environment-Id": {
        "name": "X-Environment-Id",
        "in": "header",
        "required": false,
        "description": "The environment UUID identifier. Send it to address environment scope. This API is also published at tenant scope — send that scope's header instead. Send exactly one scope header per request.",
        "schema": {
          "type": "string",
          "format": "uuid",
          "pattern": "^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$",
          "example": "e77c1408-10c8-4007-b177-abc9157fbcaa"
        }
      }
    },
    "securitySchemes": {
      "oauth2": {
        "type": "oauth2",
        "description": "Obtain an access token by calling the API Gateway's token endpoint using the OAuth2 client-credentials flow.",
        "flows": {
          "clientCredentials": {
            "tokenUrl": "https://{region}.api.jamfcloud.com/auth/token",
            "scopes": {
              "access-management:read": "",
              "access-management:update": "",
              "account-groups:read": "",
              "accounts:create": "",
              "accounts:delete": "",
              "accounts:read": "",
              "accounts:update": "",
              "activation-code:read": "",
              "activation-code:update": "",
              "ad-cs-settings:create": "",
              "ad-cs-settings:delete": "",
              "ad-cs-settings:read": "",
              "ad-cs-settings:update": "",
              "advanced-device-searches:create": "",
              "advanced-device-searches:delete": "",
              "advanced-device-searches:read": "",
              "advanced-device-searches:update": "",
              "advanced-user-searches:create": "",
              "advanced-user-searches:delete": "",
              "advanced-user-searches:read": "",
              "advanced-user-searches:update": "",
              "apache-tomcat-settings:update": "",
              "app-request:read": "",
              "app-request:update": "",
              "apple-configurator-enrollment:read": "",
              "apple-configurator-enrollment:update": "",
              "applications:create": "",
              "applications:delete": "",
              "applications:read": "",
              "applications:update": "",
              "buildings:create": "",
              "buildings:delete": "",
              "buildings:read": "",
              "buildings:update": "",
              "cache:read": "",
              "cache:update": "",
              "categories:create": "",
              "categories:delete": "",
              "categories:read": "",
              "categories:update": "",
              "change-password:execute": "",
              "cloud-distribution-point:read": "",
              "cloud-distribution-point:update": "",
              "cloud-services-settings:read": "",
              "cloud-services-settings:update": "",
              "computer-check-in:read": "",
              "computer-check-in:update": "",
              "computer-device-lock-pin:read": "",
              "computer-inventory-collection-settings:read": "",
              "computer-inventory-collection-settings:update": "",
              "conditional-access:read": "",
              "custom-paths:create": "",
              "custom-paths:delete": "",
              "declarations:read": "",
              "departments:create": "",
              "departments:delete": "",
              "departments:read": "",
              "departments:update": "",
              "destructive-device-actions:execute": "",
              "device-actions:execute": "",
              "device-actions:read": "",
              "device-compliance-information:read": "",
              "device-enrollment-program-instances:create": "",
              "device-enrollment-program-instances:delete": "",
              "device-enrollment-program-instances:read": "",
              "device-enrollment-program-instances:update": "",
              "device-groups:create": "",
              "device-groups:delete": "",
              "device-groups:read": "",
              "device-groups:update": "",
              "devices:create": "",
              "devices:read": "",
              "devices:update": "",
              "digicert-settings:create": "",
              "digicert-settings:delete": "",
              "digicert-settings:read": "",
              "digicert-settings:update": "",
              "disk-encryption-recovery-key:read": "",
              "dismiss-notifications:execute": "",
              "distribution-points:create": "",
              "distribution-points:delete": "",
              "distribution-points:read": "",
              "distribution-points:update": "",
              "dock-items:create": "",
              "dock-items:delete": "",
              "dock-items:read": "",
              "dock-items:update": "",
              "ebooks:read": "",
              "enrollment-customization:create": "",
              "enrollment-customization:delete": "",
              "enrollment-customization:read": "",
              "enrollment-customization:update": "",
              "enrollment-profiles:read": "",
              "extension-attributes:create": "",
              "extension-attributes:delete": "",
              "extension-attributes:read": "",
              "extension-attributes:update": "",
              "gsx-connection:read": "",
              "gsx-connection:update": "",
              "impact-alert-notification-settings:read": "",
              "impact-alert-notification-settings:update": "",
              "inventory-preload-records:create": "",
              "inventory-preload-records:delete": "",
              "inventory-preload-records:read": "",
              "inventory-preload-records:update": "",
              "jamf-cloud-distribution-service-files:create": "",
              "jamf-cloud-distribution-service-files:delete": "",
              "jamf-cloud-distribution-service-files:read": "",
              "jamf-connect-deployments:deploy": "",
              "jamf-connect-deployments:read": "",
              "jamf-connect-deployments:update": "",
              "jamf-packages-action:read": "",
              "jamf-protect-deployments:deploy": "",
              "jamf-protect-deployments:read": "",
              "jamf-protect-deployments:update": "",
              "jss-information:read": "",
              "jss-url:read": "",
              "jss-url:update": "",
              "ldap-servers:create": "",
              "ldap-servers:delete": "",
              "ldap-servers:read": "",
              "ldap-servers:update": "",
              "local-admin-passwords:execute": "",
              "local-admin-passwords:read": "",
              "local-admin-passwords:update": "",
              "login-disclaimer:update": "",
              "m2m:read": "",
              "managed-software-updates:create": "",
              "managed-software-updates:read": "",
              "managed-software-updates:update": "",
              "mdm-profile-renewal-settings:read": "",
              "mdm-profile-renewal-settings:update": "",
              "onboarding:read": "",
              "onboarding:update": "",
              "packages:create": "",
              "packages:delete": "",
              "packages:read": "",
              "packages:update": "",
              "parent-app:read": "",
              "parent-app:update": "",
              "patch-management-software-titles:create": "",
              "patch-management-software-titles:delete": "",
              "patch-management-software-titles:read": "",
              "patch-management-software-titles:update": "",
              "patch-policies:read": "",
              "patch-policies:update": "",
              "pki:read": "",
              "pki:update": "",
              "policies:read": "",
              "policies:update": "",
              "prestage-enrollments:create": "",
              "prestage-enrollments:delete": "",
              "prestage-enrollments:read": "",
              "prestage-enrollments:update": "",
              "push-certificates:read": "",
              "push-certificates:update": "",
              "re-enrollment:read": "",
              "re-enrollment:update": "",
              "recovery-lock:execute": "",
              "recovery-lock:read": "",
              "remote-administration:create": "",
              "remote-administration:delete": "",
              "remote-administration:read": "",
              "remote-administration:update": "",
              "remote-assist:read": "",
              "retention-policy:read": "",
              "retention-policy:update": "",
              "return-to-service:delete": "",
              "return-to-service:read": "",
              "return-to-service:update": "",
              "scripts:create": "",
              "scripts:delete": "",
              "scripts:read": "",
              "scripts:update": "",
              "self-service:create": "",
              "self-service:delete": "",
              "self-service:read": "",
              "self-service:update": "",
              "sites:read": "",
              "smtp-server:read": "",
              "smtp-server:update": "",
              "sso-settings:read": "",
              "sso-settings:update": "",
              "teacher-app:read": "",
              "teacher-app:update": "",
              "user-groups:read": "",
              "user-groups:update": "",
              "user-initiated-enrollment:read": "",
              "user-initiated-enrollment:update": "",
              "user-sessions:read": "",
              "users:create": "",
              "users:delete": "",
              "users:read": "",
              "users:update": "",
              "volume-purchasing-locations:create": "",
              "volume-purchasing-locations:delete": "",
              "volume-purchasing-locations:read": "",
              "volume-purchasing-locations:update": ""
            }
          }
        }
      }
    }
  },
  "x-scope-types": [
    "tenant",
    "environment"
  ]
}
```